/*
    top - TOP calculation
    Copyright (C) 2010 Ladislav Vaiz <ok1zia@nagano.cz>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    version 2 as published by the Free Software Foundation.

*/

#include "main.h"
#include "compare.h"

int top = 0;

void make_top(uint8_t band, FILE *htm, FILE *txt){
	DEBUG_FUNC("make_top");
    int l, num, i;
    char text[256];
	struct CALL_INFO *c;
	struct QSO_INFO *q, **topq;;


	if (top <= 0) return;	

    if (band >= BAND_GHZ) {
        if (band >= BAND_GHZ_ZERO)
            sprintf(text, "%2.0f GHz", band2freq[band]);
        else
            sprintf(text, "%2.1f GHz", band2freq[band]);
    } else
        sprintf(text, "%2.0f MHz", band2freq[band]);

    fprintf(htm, "<h2>TOP%d QSOs for %s:</h2>\n", top, text);
	fprintf(txt,  "\nTop%d QSOs for %s:\n\n", top, text);
   
	
	topq = malloc(top * sizeof(struct QSO_INFO*));

    num = 0;
	for (c = first_call[band]; c != NULL; c = c->next){
		if (c->categ == 0) continue;
        if (c->first_qso == NULL) continue;
        for (q = c->first_qso; q != NULL; q=q->next){
			int j;
			//q->QRB = QRB(c->loc, q->ok_call->loc);
           	for (i=0; i<num; i++){
				if (q->ok_qso == topq[i]) goto next;
                if (q->qrb > topq[i]->qrb) break;
			}
			if (i == top) continue;
			//memmove(topq+i, topq+i+1, (top-i-1)*sizeof(struct QSO_INFO*));
            for (j=num-1; j>=i; j--) topq[j+1] = topq[j];
	   // 	for (j=0; j<num; j++) printf("%d  ", topq[j]->QRB);
			topq[i]=q;
			if (num < top) num++;
			//if (num==5) exit(0);
next:;			
		}
	}

	
	fprintf(htm, "<table class=\"sortable\">\n");
	fprintf(htm, "<tr><th>Pl.</th><th>Call 1</th><th></th><th>Call 2</th><th>QRB</th></tr>");
	for (i=0; i<num; i++){
        fprintf(htm, "<tr><td>%d.</td><td>%s</td><td>-</td><td>%s</td><td>%d km</td></tr>\n", i+1, topq[i]->s_call->call, topq[i]->ok_call->call, topq[i]->qrb);
//        fprintf(htm, "%d. %s - %s %dkm<br>\n", i+1, topq[i]->s_call->call, topq[i]->ok_call->call, topq[i]->QRB);
        fprintf(txt, "%2d. %-10s - %-10s  %dkm\n", i+1, topq[i]->s_call->call, topq[i]->ok_call->call, topq[i]->qrb);
	}
	
    fprintf(htm, "</table></p><hr><br>\n");
	fprintf(txt, "\n\n");
}
